/* start -- simulates start command of Windows CMD.EXE.  */

#include <windows.h>
#include <shellapi.h>
#include <stdlib.h>

int
main ( int argc, char * argv[] )
{
    int i, n;
    int err, ret;
    char * p, * s;
    static char msg[256];
    HWND hWnd;
    HINSTANCE hInstance;

    /* We have no parent (owner) window.  */
    hWnd = NULL;

    if ( argc == 1 ) {

	p = "";

    } else if ( argc == 2 ) {

	p = argv[1];

    } else {

	/* By design, we don't allow two or more target files on the
	   command line.  So, if this program gets two or more argv
	   strings, we assume the user typed a filename that contains
	   space characters without double quotes.  The following code
	   should recover the intended target filename.  */
	n = 0;
	for ( i = 1; i < argc; i++ ) {
	    n += strlen( argv[i] ) + 2;
	}
	p = alloca( n );
	p[0] = '\0';
	for ( i = 1; i < argc; i++ ) {
	    strcat( p, argv[i] );
	    strcat( p, " " );
	}
	p[strlen( p ) - 1] = '\0';

    }

    /* Call Windows shell against the specified target file.  */
    err = ( int )ShellExecute( hWnd, NULL, p, NULL, NULL, SW_SHOWNORMAL );

    /* ... and see what happened.  */
    if ( err >= 32 ) {

	/* Win32 document says the result less than 32 indicates an
           error, nd anything else does a success...  */
	return EXIT_SUCCESS;

    } else {

	hInstance = GetModuleHandle( NULL );

	/* An error occured.  Extract the corresponding message.  */
	ret = LoadString( hInstance, err, msg, sizeof ( msg ) - 1 );

	/* If we couldn't get an appropriate message, try default.  */
	if ( ret < 0 ) {
	    ret = LoadString( hInstance, 32, msg, sizeof ( msg ) - 1 );
	    
	    /* If we still couldn't get a message, use a stupid one.  */
	    strncpy( msg, "%s: ??? (%d)", sizeof ( msg ) );
	}

	/* Allocate a buffer and format the message into it.  */
	s = alloca( strlen( p ) + sizeof ( msg ) + 256 );
	sprintf( s, msg, p, err );

	/* Show the message and return with a failure.  */
	MessageBox( hWnd, s, NULL, MB_OK | MB_ICONERROR );
	return EXIT_FAILURE;
    }
}
